<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Teach Dispense Tools</title>
<link href="../std.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
.style1 {color: #FFFFFF}
.style2 {
	font-size: x-small;
	font-weight: bold;
}
-->
</style>
</head>
<!-- ======================================================================= -->
<!--  This software is the property of Precise Automation and can be freely  -->
<!--  copied and used by Precise's customers so long as this notice is       -->
<!--  included with any modified or unmodified version of this software.     -->
<!-- ======================================================================= -->

<!--  Commented out to prevent dialog box monitoring.  This is handled by a calibration
      window. 

<script type="text/javascript" src="/flash/appweb/shared/dlgscripts.asp"></script>
<script type="text/javascript" src="/flash/appweb/shared/dlgauto.js"></script>
<iframe src="/flash/appweb/shared/dlgbutton.asp" name="dlgButton" id="dlgButton" style="position:absolute; width:304px; height:5px; z-index:101; left: 15px; top: 586px; visibility: hidden;" frameborder="2" vspace="0" hspace="0" scrolling="no" marginwidth="0" marginheight="0"></iframe>

 -->

<script language="JavaScript" src="../shared/common.js"></script>
<script language="JavaScript" src="../shared/cmdsnd.js"></script>
<script type="text/javascript" src="../shared/stopenter.js"></script>
<script>
	
	var blinkState;
	var lastIdx = 0;
	var blinkActive = 0;
	var timerID
	var disEvent = false;	//used during updating form to prevent double events
	
	// This method is automatically called at the completion of a sent command.
	// Based on the function the user can determine what to do for the page (update, refresh etc).
	function cmdReply(LastCmd,Stt,SttStr){
			if(Stt<0){
				// alert(Stt + " " + SttStr);
			}
			if(LastCmd=="visionrun"){
				//alert(Stt+","+SttStr);
			}
			if(LastCmd=="visioncalibrate"){
				updateTool(Stt,SttStr);
			}
			if(LastCmd=="visiongetinfo"){
				updateTool(Stt,SttStr);
			}
			if(LastCmd=="visionteach"){
				updateTool(Stt,SttStr);
			}
			if(LastCmd=="visionsetinfo"){
				disEvent=false;
			}
			setPageBusy(false);
			disEvent=false;
		
	}

	// based on the passed string, decode and update specified tool.  The tool property
	// is based on the first item in the string '0|' or '1|'.
function updateTool(status,data){
	var Pdata = new Array();
//	alert(data);
	if(status==0){
		Pdata = data.split("|")
		//alert(data);
		var caltbl = document.getElementById("tblCal")
		document.getElementById("txtIp").value=Pdata[0];	//IP string
		caltbl.rows[1].cells[0].innerHTML = formatNumber(Pdata[1], 4, true, false);
		caltbl.rows[1].cells[1].innerHTML = formatNumber(Pdata[2], 4, true, false);
		caltbl.rows[1].cells[2].innerHTML = formatNumber(Pdata[3], 4, true, false);
		caltbl.rows[1].cells[3].innerHTML = formatNumber(Pdata[4], 4, true, false);
		caltbl.rows[1].cells[4].innerHTML = formatNumber(Pdata[5], 4, true, false);
		caltbl.rows[1].cells[5].innerHTML = formatNumber(Pdata[6], 4, true, false);

		if(Pdata[7]==0){
			document.frmMount.chkMount[0].checked=true;
			document.frmMount.chkMount[1].checked=false;
		}
		else{
			document.frmMount.chkMount[0].checked=false;
			document.frmMount.chkMount[1].checked=true;
		}
	}
	else{
	//	document.getElementById("txtXi"+idx).value="";
	//	document.getElementById("txtYi"+idx).value="";
	//	document.getElementById("txtZi"+idx).value="";
	//	document.getElementById("txtyai"+idx).value="";
	//	document.getElementById("txtpi"+idx).value="";
	//	document.getElementById("txtri"+idx).value="";

	//	document.getElementById("txtXoff"+idx).value="";
	//	document.getElementById("txtYoff"+idx).value="";
	//	document.getElementById("txtZoff"+idx).value="";
	//	document.getElementById("txtyaoff"+idx).value="";
	//	document.getElementById("txtpoff"+idx).value="";
	//	document.getElementById("txtroff"+idx).value="";

	}
}


	function updateForm(){
		lastIdx = 1;
		var cmd = "visiongetinfo"
		var arg1 = 0
		var arg2 = ""
		var arg3 = ""
		var arg4 = ""
		sndCmd(cmd, arg1, arg2, arg3, arg4)
	}
	function cmdSave(){
		wLaunch("dialog")
		var cmd = "visionsave"
		var arg1 = ""
		var arg2 = ""
		var arg3 = ""
		var arg4 = ""
		setPageBusy(true);
		sndCmd(cmd, arg1, arg2, arg3, arg4)
	}
	function cmdSetIp(){
		var cmd = "visionsetip"
		var arg1 = document.getElementById("txtIp").value;
		var arg2 = ""
		var arg3 = ""
		var arg4 = ""
		setPageBusy(true);
		sndCmd(cmd, arg1, arg2, arg3, arg4)
	}

	function cmdTeach(index){
		wLaunch("dialog")
		lastIdx=index;
		var cmd = "visionteach"
		var arg1 = index
		var arg2 = ""
		var arg3 = ""
		var arg4 = ""
		setPageBusy(true);
		sndCmd(cmd, arg1, arg2, arg3, arg4)
	}
	
	function cmdCalibrate(){

		wLaunch("dialog")
		// open up the dialog page to.
		var cmd = "visioncalibrate"
		var arg1 = ""
		var arg2 = ""
		var arg3 = ""
		var arg4 = ""
		setPageBusy(true);
		sndCmd(cmd, arg1, arg2, arg3, arg4)
		
	}
	function wLaunch(sWin){	//launch specific wizard
		var attr = "status,width=450,height=300,noscrollbars"
		if(sWin=="dialog"){
			var newWin=window.open("/flash/appweb/shared/dlgpopup.asp","vDialog",attr)
			newWin.focus()
		}
	}
	// run vision process
	function cmdRunProcess(){
		wLaunch("dialog")
		var cmd = "visionrun"
		var arg1 = document.getElementById("txtProcess").value
		var arg2 = ""
		var arg3 = ""
		var arg4 = ""
		setPageBusy(true);
		sndCmd(cmd, arg1, arg2, arg3, arg4)
	}

	function cmdMove(index){
		wLaunch("dialog")
		lastIdx=index;
		var cmd = "movepicture"
		var arg1 = index
		var arg2 = 0		//force no tool for now
		setPageBusy(true);
		sndCmd(cmd,arg1,arg2,"","")
	}	
	
	function txtChanged(tool,mode){
		if(disEvent==false){
				disEvent=true;
				setTool(tool);
		}
	}
	
	function setTool(tool){
			var cmd = "visionsetinfo"
			var arg1 = getInfo(0,0);
			var arg2 = ""
			var arg3 = ""
			//alert(arg2);
			if(cmdBusy==false){		//internal scipt flag, prevent double cmd calls
				sndCmd(cmd, arg1, arg2, arg3, "")
			}
	}
	
	function getInfo(idx,mode){
		var strOut = ""
		strOut+= document.getElementById("txtIp").value+"|";
		strOut+= "0|0|0|0|0|0|";
		if(document.frmMount.chkMount[0].checked==true){
			strOut+="0";		
		}
		else{
			strOut+="1";
		}
//		strOut+=document.getElementById("chkMount")[0].value;
//		document.frmTable.rgDin[0].checked=true;
//		document.frmTable.rgDin[1].checked=false;
		
		return strOut;
	}
	
	function setPageBusy(stt){
		var SttTab = document.getElementById("tblStt");

		if(stt==true){
			SttTab.rows[0].cells[0].style.textAlign="center";
			SttTab.rows[0].cells[0].style.fontWeight="Bold";		
			SttTab.rows[0].cells[0].style.backgroundColor="Yellow";
			SttTab.rows[0].cells[0].innerHTML = "Busy ..."
			if(blinkActive==0){
				timerID=setInterval("blinkBusy()",500);
			}
			blinkActive = 1;
		}
		else{
			SttTab.rows[0].cells[0].style.textAlign="center";
			SttTab.rows[0].cells[0].style.fontWeight="Bold";		
			SttTab.rows[0].cells[0].style.backgroundColor="";
			SttTab.rows[0].cells[0].innerHTML = ""
			clearInterval(timerID);
			blinkActive = 0;		
		}
	}

function blinkBusy(){
	//alert("here");
	var w = document.getElementById("tblStt")
	if(blinkState==0){
		blinkState=1;
		w.rows[0].cells[0].style.backgroundColor="Yellow";
	}
	else{
		blinkState=0;
		w.rows[0].cells[0].style.backgroundColor="";
	}
}
</script>
<body onLoad="updateForm()">
<table border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="31" height="31" background="../Images/ul.jpg">&nbsp;</td>
    <td width="300" background="../Images/uu.jpg" class="leftBottom style1">Precise Vision Configuration </td>
    <td width="31" height="31" background="../Images/ur.jpg"><a href="#"><img src="../help/Images/help.gif" width="24" height="24" border="0" onClick="hLaunch('gdsi_cfg_vision.htm')"></a></td>
  </tr>
  <tr>
    <td background="../Images/lm.jpg">&nbsp;</td>
    <td width="300"><table border="0" cellspacing="3" cellpadding="0">
      <tr>
        <td class="HDocumentation"><p>Please following the following steps to use PreciseVision with Guidance Dispense:</p>
          <ol>
            <li> Specify the IP address of the PC running PreciseVision. Enter a test process and click 'Test Vision' to ensure proper communication between GD and PV.</li>
            <li>Select 'Fix Mounted' or 'Arm Mounted' based on where the camera will be mounted.</li>
            <li>Click 'Calibration Setup' to begin the process. Follow the instructions to complete the camera calibration process. </li>
          </ol>          
          <p>Note: PreciseVision will teach a picture point which is stored on the flash. This point is used by Guidance Dispense. </p>
          <p>For ARM mounted camera, this point needs to be taught so the camera is in focus for the working surface of the robot. </p>
          <p>If this is a FIXED mounted camera, this point is used to move the robot out of the way of the camera prior to taking a picture.</p>
          </td>
      </tr>
      <tr>
        <td class="HDocumentation">&nbsp;</td>
      </tr>
      <tr>
        <td class="sDefault"><div align="center"><strong>IP address of vision server. </strong></div></td>
      </tr>
      <tr>
        <td class="HDocumentation"><input name="txtIp" type="text" class="smallCenter" id="txtIp" size="20" maxlength="15">
          <input name="btnVision" type="submit" class="smallCenter" id="btnVision"  onClick="cmdSetIp();" value="Set">
          Vision test Process name
           <input name="txtProcess" type="text" class="smallCenter" id="txtProcess" size="20" >
          <input name="btnVision" type="submit" class="smallCenter" id="btnVision" style="width:75px " onClick="cmdRunProcess();" value="Test Vision"></td>
      </tr>
      <tr>
        <td class="HDocumentation style2">(192.168.0.100)</td>
      </tr>
      <tr>
        <td class="sDefault"><div align="center"><strong>Select where the camera is mounted.</strong></div></td>
      </tr>
      <tr>
        <td class="HDocumentation">
		  	<form name="frmMount" id="frmMount">
            <input name="chkMount" type="radio" id="chkMount" value="1" onClick="txtChanged(0,0)">
            Fix Mounted
    		<input name="chkMount" type="radio" id="chkMount" value="0" onClick="txtChanged(0,0)"> 
    		Arm Mounted	</form>
          </td>
      </tr>
      <tr>
        <td><table width="10%"  border="0" cellspacing="0" cellpadding="1">
          <tr>
            <td colspan="3" class="sDefault"><div align="center"><strong>Camera calibration picture position. </strong></div></td>
            </tr>
          <tr>
            <td colspan="3" class="sYellow2"><strong>*Warning*</strong> The away point is taught using PreciseVision and cannot be changed within Guidance Dispense.</td>
            </tr>
          <tr>
            <td><div align="center" class="sLinearAxis">Robot</div></td>
            <td rowspan="2" class="smallCenter"><table width="370"  border="1" cellpadding="2" cellspacing="0" id="tblCal">
                <tr>
                  <td width="60"><div align="center">X</div></td>
                  <td width="60"><div align="center">Y</div></td>
                  <td width="60"><div align="center">Z</div></td>
                  <td width="60"><div align="center">Y</div></td>
                  <td width="60"><div align="center">Pitch</div></td>
                  <td width="60"><div align="center">Roll</div></td>
                </tr>
                <tr bgcolor="#CCCCCC">
                  <td width="60"><div align="center"></div></td>
                  <td width="60"><div align="center"></div></td>
                  <td width="60"><div align="center"></div></td>
                  <td width="60"><div align="center"></div></td>
                  <td width="60"><div align="center"></div></td>
                  <td width="60"><div align="center"></div></td>
                </tr>
                        </table></td>
            <td>&nbsp;</td>
          </tr>
          <tr>
            <td><input name="btnCalibrate" type="submit" class="smallCenter" id="btnCalibrate" style="width:120px " onClick="cmdCalibrate()" value="Calibration Setup"></td>
            <td><input name="btnMove" type="submit" class="smallCenter" id="btnMove" style="width:75px " onClick="cmdMove(0);" value="Move To"></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td><div align="right">
          <input name="btnMove" type="submit" id="btnMove" onClick="cmdSave();" value="Save" style="width:100px ">
        </div></td>
      </tr>
    </table></td>
    <td background="../Images/rr.jpg">&nbsp;</td>
  </tr>
  <tr>
    <td width="31" height="31" background="../Images/ll.jpg">&nbsp;</td>
    <td width="300" background="../Images/bm.jpg"><table width="200" height="20" border="0" cellpadding="0" cellspacing="0" id="tblStt">
      <tr>
        <td>&nbsp;</td>
      </tr>
    </table></td>
    <td width="31" height="31" background="../Images/lr.jpg">&nbsp;</td>
  </tr>
</table>
<p>&nbsp;</p>
</body>
<iframe name="cmdPut" id="dbPut" src="..\shared\dbputcmd.asp" style="width:500px; height:50px; z-index:101;visibility: hidden;" frameborder="1" vspace="0" hspace="0" scrolling="yes" marginwidth="0" marginheight="0">
</iframe>

</html>
